  /**********************************************************************
  *                            ResultPanel v1.1                          *
  ************************************************************************
  * Copyright (C) 2007-09 by Michael Loesler, http//derletztekick.com    *
  *                                                                      *
  * This program is free software; you can redistribute it and/or modify *
  * it under the terms of the GNU General Public License as published by *
  * the Free Software Foundation; either version 3 of the License, or    *
  * (at your option) any later version.                                  *
  *                                                                      *
  * This program is distributed in the hope that it will be useful,      *
  * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
  * GNU General Public License for more details.                         *
  *                                                                      *
  * You should have received a copy of the GNU General Public License    *
  * along with this program; if not, see <http://www.gnu.org/licenses/>  *
  * or write to the                                                      *
  * Free Software Foundation, Inc.,                                      *
  * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
  *                                                                      *
   **********************************************************************/



import java.net.URI;
import javax.swing.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.text.html.HTMLEditorKit;

class ResultPanel extends JPanel{
  private JTextPane resultJTP = new JTextPane();
  private JScrollPane jSP = new JScrollPane(this.resultJTP);

  public ResultPanel() {
    this.setLayout(new BorderLayout());
    this.resultJTP.setText("");
    this.resultJTP.setEditable(false);
    this.resultJTP.setFont(new Font("Monospaced", 0, 12));
    this.resultJTP.setEditorKit(new HTMLEditorKit());

    this.resultJTP.addHyperlinkListener(new HyperlinkListener() {
      public void hyperlinkUpdate(HyperlinkEvent h) {
        if (h.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
          String url = h.getDescription();
          if (url.toLowerCase().startsWith("http://") || url.toLowerCase().startsWith("https://") || url.toLowerCase().startsWith("ftp://")  ) {
            try { Desktop.getDesktop().browse( new URI(url) ); } catch ( Exception e ) { }
          }
          else {
            try { resultJTP.setPage(h.getURL()); } catch (Exception e) {}
          }
        }
      }
    });
    this.jSP.setViewportView( this.resultJTP );
    this.add(BorderLayout.CENTER, this.jSP );
  }

  public void setText(String str) {
    this.resultJTP.setText( "<h1 style=\"text-align:center;\">KoordTrans3D - Report</h1>"+str+"<hr><center><em>KoordTrans3D</em> &copy;2005-2009 by Michael L&ouml;sler - <a href=\"http://derletztekick.com\" title=\"powered by derletztekick.com\">derletztekick.com</a></center>" );
  }
}
