  /**********************************************************************
  *                          SettingPanel v1.32                          *
  ************************************************************************
  * Copyright (C) 2007-09 by Michael Loesler, http//derletztekick.com    *
  *                                                                      *
  * This program is free software; you can redistribute it and/or modify *
  * it under the terms of the GNU General Public License as published by *
  * the Free Software Foundation; either version 3 of the License, or    *
  * (at your option) any later version.                                  *
  *                                                                      *
  * This program is distributed in the hope that it will be useful,      *
  * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
  * GNU General Public License for more details.                         *
  *                                                                      *
  * You should have received a copy of the GNU General Public License    *
  * along with this program; if not, see <http://www.gnu.org/licenses/>  *
  * or write to the                                                      *
  * Free Software Foundation, Inc.,                                      *
  * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
  *                                                                      *
   **********************************************************************/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
public class SettingPanel extends JPanel {
  protected File sourceFile1 = null, sourceFile2 = null;
  private Vector<Point23> pointsS = null;
  private Vector<Point23> pointsZ = null;
  private Vector<Point23> ppS = null;
  private Vector<Point23> ppZ = null;
  private Vector<Point23> transPoints = null;
  private Transformation t = null;
  private JFileChooser jFC = new JFileChooser();
  
  public JCheckBox reWeight = new JCheckBox();
  public KoordTrans p = null;
  private JPanel filePanel = new JPanel();
  private JPanel trafoPanel = new JPanel();

  private JLabel transTypeInfoText = new JLabel();
  private JButton transTypeInfoButton = new JButton();

  public Vector<JTextField> sourcefilesTextfields = new Vector<JTextField>(2);
  private Vector<JLabel> sourcefilesLabels = new Vector<JLabel>(2);
  private Vector<JButton> sourcefilesButton = new Vector<JButton>(2);
  private Vector<JButton> startButton = new Vector<JButton>(2);
  
  public Vector<JTextField> approxValueTextfields = new Vector<JTextField>(9);
  private Vector<JLabel> approxValueLabels = new Vector<JLabel>(12);
  private Vector<JRadioButton> approxValueRadio = new Vector<JRadioButton>(3);
  private ButtonGroup approxValueBG = new ButtonGroup(), modelTypeBG = new ButtonGroup();
  
  public Vector<JLabel> csvSettingsLabels = new Vector<JLabel>(7);
  public Vector<JSpinner> csvSettingsSpinner = new Vector<JSpinner>(8);
  public Vector<JTextField> seperatorTextfields = new Vector<JTextField>(2);
  
  private Vector<JRadioButton> modelTypes = new Vector<JRadioButton>(2);
  
  private boolean is3DTrans = false;
  
  public ActionListener sarAl, rfAl, ofAl, sfAl, approxValueAl;

  
  public SettingPanel (KoordTrans parent) {
    this.p = parent;
    
    this.rfAl = new ActionListener(){
      public void actionPerformed( ActionEvent evt ) {
        readFilesActionPerformed(evt);
      }
    };

    this.sarAl = new ActionListener(){
      public void actionPerformed( ActionEvent evt ) {
        saveAndRunActionPerformed(evt);
      }
    };

    this.approxValueAl = new ActionListener(){
      public void actionPerformed( ActionEvent evt ) {
        approxValueActionPerformed(evt);
      }
    };
    
    this.ofAl = new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        openDialogActionPerformed(evt);
      }
    };
    
    this.sfAl = new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        saveDialogActionPerformed(evt);
      }
    };


    
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    c.fill = GridBagConstraints.HORIZONTAL;
    c.anchor = GridBagConstraints.CENTER;
    c.weightx = 0;
    c.weighty = 0;
    c.insets = new Insets(5,10,5,10);
    int yGrid = 0;
    

    this.setLayout(new GridLayout(2, 1));
    this.setBorder( BorderFactory.createEmptyBorder(10, 10, 10, 10) );
    
    this.sourcefilesTextfields.add( new JTextField( this.p.lc.getEntry("Texfields",0) ) );
    this.sourcefilesTextfields.add( new JTextField( this.p.lc.getEntry("Texfields",1) ) );
    this.sourcefilesLabels.add( new JLabel(this.p.lc.getEntry("Labels",0)) );
    this.sourcefilesLabels.add( new JLabel(this.p.lc.getEntry("Labels",1)) );
    this.sourcefilesButton.add( new JButton(this.p.lc.getEntry("Buttons",0)) );
    this.sourcefilesButton.add( new JButton(this.p.lc.getEntry("Buttons",0)) );
    this.startButton.add( new JButton(this.p.lc.getEntry("Buttons",1)) );
    this.startButton.add( new JButton(this.p.lc.getEntry("Buttons",2)) );
    
    this.csvSettingsLabels.add( new JLabel(this.p.lc.getEntry("Labels",2)) );
    this.csvSettingsLabels.add( new JLabel(this.p.lc.getEntry("Labels",3)) );
    this.csvSettingsLabels.add( new JLabel(this.p.lc.getEntry("Labels",4)) );
    this.csvSettingsLabels.add( new JLabel(this.p.lc.getEntry("Labels",5)) );
    this.csvSettingsLabels.add( new JLabel(this.p.lc.getEntry("Labels",6)) );
    this.csvSettingsLabels.add( new JLabel(this.p.lc.getEntry("Labels",7)) );
    this.csvSettingsLabels.add( new JLabel(this.p.lc.getEntry("Labels",8)) );
    this.csvSettingsLabels.add( new JLabel(this.p.lc.getEntry("Labels",9)) );

    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",13)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",14)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",15)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",16)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",17)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",18)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",19)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",20)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",21)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",22)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",23)) );
    this.approxValueLabels.add( new JLabel(this.p.lc.getEntry("Labels",24)) );

    this.approxValueRadio.add( new JRadioButton(this.p.lc.getEntry("RadioButton",0),true));
    this.approxValueRadio.add( new JRadioButton(this.p.lc.getEntry("RadioButton",1),false));
    this.approxValueRadio.add( new JRadioButton(this.p.lc.getEntry("RadioButton",2),false));
    this.modelTypes.add( new JRadioButton(this.p.lc.getEntry("RadioButton",3),false ));
    this.modelTypes.add( new JRadioButton(this.p.lc.getEntry("RadioButton",4),true ));
    
    this.modelTypes.get(0).setName("GMM");
    this.modelTypes.get(1).setName("GHM");
    
    this.approxValueTextfields.add(  new JTextField( "1.0" ) );
    this.approxValueTextfields.add(  new JTextField( "0.0" ) );
    this.approxValueTextfields.add(  new JTextField( "0.0" ) );
    
    this.approxValueTextfields.add(  new JTextField( "1.0" ) );
    this.approxValueTextfields.add(  new JTextField( "0.0" ) );
    this.approxValueTextfields.add(  new JTextField( "0.0" ) );
    
    this.approxValueTextfields.add(  new JTextField( "1.0" ) );
    this.approxValueTextfields.add(  new JTextField( "0.0" ) );
    this.approxValueTextfields.add(  new JTextField( "0.0" ) );
    
    this.csvSettingsSpinner.add(  new JSpinner(new SpinnerNumberModel( 1, 1, 25, 1 )) );
    this.csvSettingsSpinner.add(  new JSpinner(new SpinnerNumberModel( 2, 1, 25, 1 )) );
    this.csvSettingsSpinner.add(  new JSpinner(new SpinnerNumberModel( 3, 1, 25, 1 )) );
    this.csvSettingsSpinner.add(  new JSpinner(new SpinnerNumberModel( 4, 1, 25, 1 )) );
    this.csvSettingsSpinner.add(  new JSpinner(new SpinnerNumberModel( 1, 1, 25, 1 )) );
    this.csvSettingsSpinner.add(  new JSpinner(new SpinnerNumberModel( 2, 1, 25, 1 )) );
    this.csvSettingsSpinner.add(  new JSpinner(new SpinnerNumberModel( 3, 1, 25, 1 )) );
    this.csvSettingsSpinner.add(  new JSpinner(new SpinnerNumberModel( 4, 1, 25, 1 )) );
    this.seperatorTextfields.add( new JTextField( this.p.lc.getEntry("Texfields",2) ) );
    this.seperatorTextfields.add( new JTextField( this.p.lc.getEntry("Texfields",3) ) );

    this.filePanel.setLayout( gbl );
    this.filePanel.setBorder( BorderFactory.createTitledBorder( this.p.lc.getEntry("BorderTitle", 2) ));
    
    this.trafoPanel.setLayout( gbl );
    this.trafoPanel.setBorder( BorderFactory.createTitledBorder( this.p.lc.getEntry("BorderTitle", 6) ));
    
    
    //SETTINGS
    c.gridwidth = 6;
    this.transTypeInfoText = new JLabel( this.p.lc.getEntry("Labels",25) );
    gbl.setConstraints( this.transTypeInfoText, c);
    this.filePanel.add( this.transTypeInfoText );
    this.transTypeInfoText.addMouseListener( new MouseAdapter() {
      public void mouseClicked( MouseEvent e ) {
        p.ToolsjTabbedPane.setSelectedIndex(1);
      }
    });
    yGrid++;
    
//    for (int i=0; i<this.modelTypes.size(); i++){
//      c.gridx = i*2;
//      c.gridy = yGrid;
//      if (i==0)
//         c.gridwidth = 2;
//      else
//        c.gridwidth = 4;
//      c.gridheight = 1;
//      c.weightx = 0;
//      this.modelTypeBG.add( this.modelTypes.get(i) );
//      gbl.setConstraints( this.modelTypes.get(i), c);
//      this.filePanel.add( this.modelTypes.get(i) );
//    }

    this.reWeight.setText(this.p.lc.getEntry("Labels", 10));
    this.reWeight.setSelected(false);
    
    c.gridx = 0;
    c.gridy = yGrid;
    c.gridwidth = 2;
    c.gridheight = 1;
    c.weightx = 0;
    
    gbl.setConstraints(this.reWeight, c);
    this.filePanel.add(this.reWeight);

    yGrid++;

    for (int i=0; i<this.sourcefilesTextfields.size(); i++){
      c.gridx = 0;
      c.gridy = yGrid;
      c.gridwidth = 1;
      c.gridheight = 1;
      c.weightx = 0;
      gbl.setConstraints(this.sourcefilesLabels.get(i), c);
      this.filePanel.add( this.sourcefilesLabels.get(i) );
      
      c.gridwidth = 3;
      c.gridx = 1;
      c.weightx = 0;
      this.sourcefilesTextfields.get(i).setEditable(false);
      gbl.setConstraints(this.sourcefilesTextfields.get(i) , c);
      this.filePanel.add( this.sourcefilesTextfields.get(i) );
      
      c.gridwidth = 2;
      c.gridx = 4;
      c.weightx = 1;
      gbl.setConstraints(this.sourcefilesButton.get(i) , c);
      this.filePanel.add( this.sourcefilesButton.get(i) );
      this.sourcefilesButton.get(i).addActionListener(this.ofAl);

      yGrid++;
    }
    
    for (int i=0, j=2; j<this.csvSettingsLabels.size(); i++, j++){
      c.gridx = i;
      c.gridy = yGrid;
      c.gridwidth = 1;
      c.gridheight = 1;
      c.weightx = 0;
      gbl.setConstraints(this.csvSettingsLabels.get(j), c);
      this.filePanel.add( this.csvSettingsLabels.get(j) );
    }
    yGrid++;

    for (int i=0, j=1, k=yGrid; i<this.csvSettingsSpinner.size(); i++, j++){
      if (j==1){
        c.gridx = j-1;
        c.gridy = yGrid;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.weightx = 0;
        gbl.setConstraints(this.csvSettingsLabels.get(yGrid-k), c);
        this.filePanel.add( this.csvSettingsLabels.get(yGrid-k) );
      }


      c.gridx = j;
      c.gridy = yGrid;
      c.gridwidth = 1;
      c.gridheight = 1;
      c.weightx = 0;
      gbl.setConstraints(this.csvSettingsSpinner.get(i) , c);
      this.filePanel.add( this.csvSettingsSpinner.get(i) );


      if ((i+1)%4==0){
        c.gridx = j+1;
        gbl.setConstraints(this.seperatorTextfields.get(yGrid-k) , c);
        this.filePanel.add( this.seperatorTextfields.get(yGrid-k) );
        yGrid++;
        j=0;
      }

    }

    //Button
    yGrid++;
    c.gridx=0;
    c.gridy = yGrid;
    c.gridwidth = 6;
    c.gridheight = 1;
    c.weightx = 1;
    
    this.startButton.get(0).addActionListener(rfAl);
    gbl.setConstraints( this.startButton.get(0) , c);
    this.filePanel.add( this.startButton.get(0) );


    
    //Trafo Einstellungen
    c.gridx = 0;
    c.gridy = 0;
    c.gridwidth = 6;
    c.gridheight = 1;
    c.weightx = 0;
    
    for (int i=0; i<this.approxValueRadio.size(); i++){
      this.approxValueRadio.get(i).addActionListener(this.approxValueAl);
      this.approxValueBG.add( this.approxValueRadio.get(i) );
      gbl.setConstraints(this.approxValueRadio.get(i) , c);
      this.trafoPanel.add( this.approxValueRadio.get(i) );
      c.gridy++;
    }

    c.gridx = 1;
    c.gridwidth = 1;
    for (int i=0; i<3; i++){
      gbl.setConstraints(this.approxValueLabels.get(i) , c);
      this.trafoPanel.add( this.approxValueLabels.get(i) );
      c.gridx+=2;
    }
    c.gridx = 0;
    c.gridy++;
    c.gridwidth = 1;
    for (int i=0; i<9; i++){
      c.weightx = 0.2;
      gbl.setConstraints(this.approxValueLabels.get(i+3) , c);
      this.trafoPanel.add( this.approxValueLabels.get(i+3) );
      c.gridx++;
      c.weightx = 0.8;
      this.approxValueTextfields.get(i).setEditable(false);
      gbl.setConstraints(this.approxValueTextfields.get(i) , c);
      this.trafoPanel.add(this.approxValueTextfields.get(i) );
      this.approxValueTextfields.get(i).setPreferredSize( new Dimension(80,20));
      c.gridx++;
      
      if ((i+1)%3==0){
        c.gridx=0;
        c.gridy++;
      }
    }

    
    //Trafo-Button
    c.gridwidth = 6;
    this.startButton.get(1).setEnabled(false);
    this.startButton.get(1).addActionListener(sarAl);
    gbl.setConstraints( this.startButton.get(1) , c);
    this.trafoPanel.add( this.startButton.get(1) );

    this.add( this.filePanel );
    this.add( this.trafoPanel );


  }
  

  
  public void saveAndRunActionPerformed(ActionEvent evt) {
    if (evt.getSource() == this.startButton.get(1)){
      if (!this.is3DTrans && this.p.transSettingP.is3DTransformation){
        JOptionPane.showMessageDialog(null, this.p.lc.getEntry("Message",5), this.p.lc.getEntry("Message",0) ,JOptionPane.ERROR_MESSAGE);
        return;
      }

      String modelType = this.getModelType();
      double Mx=1.0, My=1.0, Mz=1.0, Rx=0.0, Ry=0.0, Rz=0.0, Tx=0.0, Ty=0.0, Tz=0.0;
      if (!this.approxValueRadio.get(0).isSelected()){
        try { Mx = Double.parseDouble( this.approxValueTextfields.get(0).getText().replace(',','.') );  } catch(Exception e) {  }
        try { Rx = Double.parseDouble( this.approxValueTextfields.get(1).getText().replace(',','.') );  } catch(Exception e) {  }
        try { Tx = Double.parseDouble( this.approxValueTextfields.get(2).getText().replace(',','.') );  } catch(Exception e) {  }

        try { My = Double.parseDouble( this.approxValueTextfields.get(3).getText().replace(',','.') );  } catch(Exception e) {  }
        try { Ry = Double.parseDouble( this.approxValueTextfields.get(4).getText().replace(',','.') );  } catch(Exception e) {  }
        try { Ty = Double.parseDouble( this.approxValueTextfields.get(5).getText().replace(',','.') );  } catch(Exception e) {  }

        try { Mz = Double.parseDouble( this.approxValueTextfields.get(6).getText().replace(',','.') );  } catch(Exception e) {  }
        try { Rz = Double.parseDouble( this.approxValueTextfields.get(7).getText().replace(',','.') );  } catch(Exception e) {  }
        try { Tz = Double.parseDouble( this.approxValueTextfields.get(8).getText().replace(',','.') );  } catch(Exception e) {  }

      }
      
      this.approxValueTextfields.get(0).setText(""+Mx);
      this.approxValueTextfields.get(1).setText(""+Rx);
      this.approxValueTextfields.get(2).setText(""+Tx);

      this.approxValueTextfields.get(3).setText(""+My);
      this.approxValueTextfields.get(4).setText(""+Ry);
      this.approxValueTextfields.get(5).setText(""+Ty);

      this.approxValueTextfields.get(6).setText(""+Mz);
      this.approxValueTextfields.get(7).setText(""+Rz);
      this.approxValueTextfields.get(8).setText(""+Tz);

      this.t = null;
      this.transPoints = null;
      String s = this.p.transSettingP.getTransType();
      String rStr = new String("");

      //Transformationsparameter bestimmen
      if (this.ppS != null && this.ppZ != null && !this.approxValueRadio.get(2).isSelected()){
        this.transPoints = new Vector<Point23>();
        for (int i=0; i<this.ppS.size(); i++){
          this.ppS.get(i).setWeightX(new Double(this.p.passpointPanel.passPointTable.getValueAt(i,1).toString()).doubleValue());
          this.ppS.get(i).setWeightY(new Double(this.p.passpointPanel.passPointTable.getValueAt(i,2).toString()).doubleValue());
          this.ppS.get(i).setWeightZ(new Double(this.p.passpointPanel.passPointTable.getValueAt(i,3).toString()).doubleValue());
        
          this.ppZ.get(i).setWeightX(new Double(this.p.passpointPanel.passPointTable.getValueAt(i,4).toString()).doubleValue());
          this.ppZ.get(i).setWeightY(new Double(this.p.passpointPanel.passPointTable.getValueAt(i,5).toString()).doubleValue());
          this.ppZ.get(i).setWeightZ(new Double(this.p.passpointPanel.passPointTable.getValueAt(i,6).toString()).doubleValue());
      
          this.ppS.get(i).setPP(new Boolean(this.p.passpointPanel.passPointTable.getValueAt(i,7).toString()));
          this.ppZ.get(i).setPP(new Boolean(this.p.passpointPanel.passPointTable.getValueAt(i,7).toString()));
        }
      
        if (s.equals("2P2D1")){
          this.t = new TwoParameterTransformation2D(this.ppS, this.ppZ, Rx, Ry, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("3P2D1")){
          this.t = new ThreeParameterTransformation2D(this.ppS, this.ppZ, Rx, Tx, Ty, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("4P2D1")){
          this.t = new FourParameterTransformation2D_1(this.ppS, this.ppZ, Mx, Rx, Tx, Ty, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("4P2D2")){
          this.t = new FourParameterTransformation2D_2(this.ppS, this.ppZ, Rx, Ry, Tx, Ty, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("5P2D1")){
          this.t = new FiveParameterTransformation2D_1(this.ppS, this.ppZ, Mx, My, Rx, Tx, Ty, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("5P2D2")){
          this.t = new FiveParameterTransformation2D_2(this.ppS, this.ppZ, Mx, Rx, Ry, Tx, Ty, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("5P2D3")){
          this.t = new FiveParameterTransformation2D_3(this.ppS, this.ppZ, Mx, My, Rx, Tx, Ty, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("6P2D1")){
          this.t = new SixParameterTransformation2D(this.ppS, this.ppZ, Mx, My, Rx, Ry, Tx, Ty, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("3P3D1")){
          this.t = new ThreeParameterTransformation3D(this.ppS, this.ppZ, Rx, Ry, Rz, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("4P3D1")){
          this.t = new FourParameterTransformation3D(this.ppS, this.ppZ, Mx, Rx, Ry, Rz, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("6P3D1")){
          this.t = new SixParameterTransformation3D(this.ppS, this.ppZ, Rx, Ry, Rz, Tx, Ty, Tz, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("7P3D1")){
          this.t = new SevenParameterTransformation3D(this.ppS, this.ppZ, Mx, Rx, Ry, Rz, Tx, Ty, Tz, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("9P3D1")){
          this.t = new NineParameterTransformation3D(this.ppS, this.ppZ, Mx, My, Mz, Rx, Ry, Rz, Tx, Ty, Tz, !this.reWeight.isSelected(), modelType);
        }
        else if (s.equals("Poly2D")){
          int polyX = 0, polyY = 0;
          try { polyX = Integer.parseInt( this.p.transSettingP.settingJT.get(0).getText() );  } catch(Exception e) { polyX = 0; }
          try { polyY = Integer.parseInt( this.p.transSettingP.settingJT.get(1).getText() );  } catch(Exception e) { polyY = 0; }
          this.t = new PolynomialTransformation2D(this.ppS, this.ppZ, polyX, polyY, !this.reWeight.isSelected(), modelType) ;
        }
        else if (s.equals("Bili2D")){
          this.t = new BilinearTransformation2D(this.ppS, this.ppZ, !this.reWeight.isSelected(), modelType) ;
        }
        else if (s.equals("Proj2D")){
          this.t = new ProjectiveTransformation2D(this.ppS, this.ppZ, !this.reWeight.isSelected(), modelType) ;
        }
        if (t!=null && t.isComplete){
          rStr = "<h2>Parameter &amp; Differenz</h2><code>"+t.toString()+"</code><h2>Transformation</h2>";
          for (int i=0; i<this.pointsS.size(); i++) {
             Point23 p = this.t.transPoint(this.pointsS.get(i));
             this.transPoints.add( p );
               rStr += "<code>"+p.toHTML()+"</code><br>";
          }

        }
        else
          rStr = "<code>"+t.toString()+"</code>";
        this.p.resultP.setText( rStr );

        this.p.ToolsjTabbedPane.setSelectedIndex(  this.p.ToolsjTabbedPane.getComponentCount()-1 );
      }
      else if (this.ppS != null && this.approxValueRadio.get(2).isSelected()){
        // Transformationsparameter schon vorgegeben
        this.transPoints = new Vector<Point23>();
        for (int i=0; i<this.ppS.size(); i++){
          this.ppS.get(i).setWeightX(new Double(this.p.passpointPanel.passPointTable.getValueAt(i,1).toString()).doubleValue());
          this.ppS.get(i).setWeightY(new Double(this.p.passpointPanel.passPointTable.getValueAt(i,2).toString()).doubleValue());
          this.ppS.get(i).setWeightZ(new Double(this.p.passpointPanel.passPointTable.getValueAt(i,3).toString()).doubleValue());

          this.ppS.get(i).setPP(new Boolean(this.p.passpointPanel.passPointTable.getValueAt(i,7).toString()));
        }

        if (s.equals("2P2D1")){
          this.t = new TwoParameterTransformation2D(Rx, Ry);
        }
        else if (s.equals("3P2D1")){
          this.t = new ThreeParameterTransformation2D(Rx, Tx, Ty);
        }
        else if (s.equals("4P2D1")){
          this.t = new FourParameterTransformation2D_1(Mx, Rx, Tx, Ty);
        }
        else if (s.equals("4P2D2")){
          this.t = new FourParameterTransformation2D_2(Rx, Ry, Tx, Ty);
        }
        else if (s.equals("5P2D1")){
          this.t = new FiveParameterTransformation2D_1(Mx, My, Rx, Tx, Ty);
        }
        else if (s.equals("5P2D2")){
          this.t = new FiveParameterTransformation2D_2(Mx, Rx, Ry, Tx, Ty);
        }
        else if (s.equals("5P2D3")){
          this.t = new FiveParameterTransformation2D_3(Mx, My, Rx, Tx, Ty) ;
        }
        else if (s.equals("6P2D1")){
          this.t = new SixParameterTransformation2D(Mx, My, Rx, Ry, Tx, Ty) ;
        }
        else if (s.equals("3P3D1")){
          this.t = new ThreeParameterTransformation3D(Rx, Ry, Rz) ;
        }
        else if (s.equals("4P3D1")){
          this.t = new FourParameterTransformation3D(Mx, Rx, Ry, Rz);
        }
        else if (s.equals("6P3D1")){
          this.t = new SixParameterTransformation3D(Rx, Ry, Rz, Tx, Ty, Tz);
        }
        else if (s.equals("7P3D1")){
          this.t = new SevenParameterTransformation3D(Mx, Rx, Ry, Rz, Tx, Ty, Tz);
        }
        else if (s.equals("9P3D1")){
          this.t = new NineParameterTransformation3D(Mx, My, Mz, Rx, Ry, Rz, Tx, Ty, Tz) ;
        }
        else {
          JOptionPane.showMessageDialog(null, this.p.lc.getEntry("Message",4), this.p.lc.getEntry("Message",0) ,JOptionPane.ERROR_MESSAGE);
          return;
        }

        if (t!=null && t.isComplete){
          rStr = "<h2>Transformation</h2>";
          for (int i=0; i<this.ppS.size(); i++)
            if (this.ppS.get(i).isPP()) {
                Point23 p = t.transPoint(this.ppS.get(i));
                this.transPoints.add( p );
                rStr += "<code>"+p.toHTML()+"</code><br>";
            }

        }
        
        this.p.resultP.setText( rStr );
        this.p.ToolsjTabbedPane.setSelectedIndex( this.p.ToolsjTabbedPane.getComponentCount()-1 );
      
      }
      else {
        JOptionPane.showMessageDialog(null, this.p.lc.getEntry("Message",2), this.p.lc.getEntry("Message",0) ,JOptionPane.ERROR_MESSAGE);
      }
    }
  }
  
  public Transformation getTransformation() {
       return this.t;
  }
  
  public boolean saveFileActionPerformed(File f) {
     boolean isComplete = false;
     if (this.transPoints == null)
       return isComplete;
     PrintWriter pw = null;
     String sep = this.seperatorTextfields.get(1).getText();
     try {
        pw = new PrintWriter(new BufferedWriter(new FileWriter( f )));

        for (int i=0; i<this.transPoints.size(); i++) {
            Point23 p = this.transPoints.get(i);
            if (!p.is3DPoint())
                pw.printf(Locale.ENGLISH, "%10s"+sep+" %+17.6f"+sep+" %+17.6f", p.getPKT(), p.getX(), p.getY()  );
            else
                pw.printf(Locale.ENGLISH, "%10s"+sep+" %+17.6f"+sep+" %+17.6f"+sep+" %+17.6f ", p.getPKT(), p.getX(), p.getY(), p.getZ()  );
            pw.println();
        }
        isComplete = true;
     } catch (IOException e) {
        e.printStackTrace();
     }
     finally {
        if (pw != null) {
            pw.close();
        }
     }
     return isComplete;
  }
  
  public void readFilesActionPerformed(ActionEvent evt) {
    if (evt.getSource() == this.startButton.get(0) && this.sourceFile1 != null && this.sourceFile2 != null && !this.approxValueRadio.get(2).isSelected()){
      this.pointsS = null;
      this.pointsZ = null;
      CSVFileReader csvfr = new CSVFileReader(this.sourceFile1);
      this.pointsS = csvfr.getPointsFromFile( this.seperatorTextfields.get(0).getText(),
                                         new Integer(this.csvSettingsSpinner.get(0).getValue().toString()),
                                         new Integer(this.csvSettingsSpinner.get(1).getValue().toString()),
                                         new Integer(this.csvSettingsSpinner.get(2).getValue().toString()),
                                         (this.p.transSettingP.is3DTransformation)?new Integer(this.csvSettingsSpinner.get(3).getValue().toString()):null
                                        );

      csvfr = new CSVFileReader(this.sourceFile2);
      this.pointsZ = csvfr.getPointsFromFile( this.seperatorTextfields.get(1).getText(),
                                         new Integer(this.csvSettingsSpinner.get(4).getValue().toString()),
                                         new Integer(this.csvSettingsSpinner.get(5).getValue().toString()),
                                         new Integer(this.csvSettingsSpinner.get(6).getValue().toString()),
                                         (this.p.transSettingP.is3DTransformation)?new Integer(this.csvSettingsSpinner.get(3).getValue().toString()):null
                                        );
      if (this.pointsS == null || this.pointsZ == null){
        JOptionPane.showMessageDialog(null, this.p.lc.getEntry("Message",1), this.p.lc.getEntry("Message",0) ,JOptionPane.ERROR_MESSAGE);
        return;
      }

      this.ppS = new Vector<Point23>();
      this.ppZ = new Vector<Point23>();
      for (int i=0; i<this.pointsS.size(); i++)
        for (int j=0; j<this.pointsZ.size(); j++)
          if (this.pointsS.get(i).getPKT().equals(this.pointsZ.get(j).getPKT()) && this.p.transSettingP.is3DTransformation==this.pointsS.get(i).is3DPoint()){
            this.ppS.add(this.pointsS.get(i));
            this.ppZ.add(this.pointsZ.get(j));
          }
      if (this.ppS.size()==0){
        JOptionPane.showMessageDialog(null, this.p.lc.getEntry("Message",2), this.p.lc.getEntry("Message",0) ,JOptionPane.ERROR_MESSAGE);
        return;
      }

      this.p.passpointPanel.jSP.remove(this.p.passpointPanel.passPointTable);
      this.p.passpointPanel.passPointTable.setModel( new PPTableModel(this.ppS.size(),this.p.transSettingP.is3DTransformation ) );
      for (int i=0; i<this.ppS.size();i++) {
        this.p.passpointPanel.passPointTable.setValueAt( this.ppS.get(i).getPKT(), i,0 );
        this.p.passpointPanel.passPointTable.setValueAt( "1", i,1 );
        this.p.passpointPanel.passPointTable.setValueAt( "1", i,2 );
        if (this.p.transSettingP.is3DTransformation)
          this.p.passpointPanel.passPointTable.setValueAt( "1", i,3 );
        else
          this.p.passpointPanel.passPointTable.setValueAt( "0", i,3 );
        this.p.passpointPanel.passPointTable.setValueAt( "1", i,4 );
        this.p.passpointPanel.passPointTable.setValueAt( "1", i,5 );
        if (this.p.transSettingP.is3DTransformation)
          this.p.passpointPanel.passPointTable.setValueAt( "1", i,6 );
        else
          this.p.passpointPanel.passPointTable.setValueAt( "0", i,6 );
        this.p.passpointPanel.passPointTable.setValueAt( true, i,7 );
      }

      this.p.passpointPanel.jSP.getViewport().add(this.p.passpointPanel.passPointTable);
      this.startButton.get(1).setEnabled(true);

    }
    else if (evt.getSource() == this.startButton.get(0) && this.sourceFile1 != null && this.approxValueRadio.get(2).isSelected()){
      this.pointsS = null;
      CSVFileReader csvfr = new CSVFileReader(this.sourceFile1);
      this.pointsS = csvfr.getPointsFromFile( this.seperatorTextfields.get(0).getText(),
                                         new Integer(this.csvSettingsSpinner.get(0).getValue().toString()),
                                         new Integer(this.csvSettingsSpinner.get(1).getValue().toString()),
                                         new Integer(this.csvSettingsSpinner.get(2).getValue().toString()),
                                         (this.p.transSettingP.is3DTransformation)?new Integer(this.csvSettingsSpinner.get(3).getValue().toString()):null
                                        );
      if (this.pointsS == null){
        JOptionPane.showMessageDialog(null, this.p.lc.getEntry("Message",1), this.p.lc.getEntry("Message",0) ,JOptionPane.ERROR_MESSAGE);
        return;
      }

      this.ppS = new Vector<Point23>();
      for (int i=0; i<this.pointsS.size(); i++)
        this.ppS.add(this.pointsS.get(i));

      if (this.ppS.size()==0){
        JOptionPane.showMessageDialog(null, this.p.lc.getEntry("Message",2), this.p.lc.getEntry("Message",0) ,JOptionPane.ERROR_MESSAGE);
        return;
      }

      this.p.passpointPanel.jSP.remove(this.p.passpointPanel.passPointTable);
      this.p.passpointPanel.passPointTable.setModel( new PPTableModel(this.ppS.size(),this.p.transSettingP.is3DTransformation ) );
      for (int i=0; i<this.ppS.size();i++) {
        this.p.passpointPanel.passPointTable.setValueAt( this.ppS.get(i).getPKT(), i,0 );
        this.p.passpointPanel.passPointTable.setValueAt( "1", i,1 );
        this.p.passpointPanel.passPointTable.setValueAt( "1", i,2 );
        if (this.p.transSettingP.is3DTransformation)
          this.p.passpointPanel.passPointTable.setValueAt( "1", i,3 );
        else
          this.p.passpointPanel.passPointTable.setValueAt( "0", i,3 );
        this.p.passpointPanel.passPointTable.setValueAt( "1", i,4 );
        this.p.passpointPanel.passPointTable.setValueAt( "1", i,5 );
        if (this.p.transSettingP.is3DTransformation)
          this.p.passpointPanel.passPointTable.setValueAt( "1", i,6 );
        else
          this.p.passpointPanel.passPointTable.setValueAt( "0", i,6 );
        this.p.passpointPanel.passPointTable.setValueAt( true, i,7 );
      }

      this.p.passpointPanel.jSP.getViewport().add(this.p.passpointPanel.passPointTable);
      this.startButton.get(1).setEnabled(true);
                                        
    }
    
    else {
      JOptionPane.showMessageDialog(null, this.p.lc.getEntry("Message",3), this.p.lc.getEntry("Message",0) ,JOptionPane.ERROR_MESSAGE);
    }

    this.is3DTrans = this.p.transSettingP.is3DTransformation;
  }
  
  public void saveDialogActionPerformed(ActionEvent evt) {
    if (evt.getSource()==this.p.spTransItem){
      if (this.sourceFile1 != null){
        jFC.setCurrentDirectory( this.sourceFile1 );
        jFC.setSelectedFile( this.sourceFile1 );
      }
      
      jFC.setDialogType(JFileChooser.SAVE_DIALOG);
      jFC.setDialogTitle(this.p.lc.getEntry("Savedialog", 0));
      jFC.setApproveButtonText(this.p.lc.getEntry("Savedialog", 1));
      
      if (jFC.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
        this.saveFileActionPerformed( jFC.getSelectedFile() );
      }
    }
  }
  
  public void openDialogActionPerformed(ActionEvent evt) {
    if (evt.getSource() == this.sourcefilesButton.get(0) || evt.getSource()==this.p.opSItem){
      if (this.sourceFile1 != null){
        jFC.setCurrentDirectory( this.sourceFile1 );
        jFC.setSelectedFile( this.sourceFile1 );
      }
      else if (this.sourceFile2 != null){
        jFC.setCurrentDirectory( this.sourceFile2 );
        jFC.setSelectedFile( this.sourceFile2 );
      }
      jFC.setDialogType(JFileChooser.OPEN_DIALOG);
      jFC.setDialogTitle(this.p.lc.getEntry("Opendialog", 0));
      jFC.setApproveButtonText(this.p.lc.getEntry("Opendialog", 1));

      if (jFC.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
        this.sourceFile1 = jFC.getSelectedFile();
        this.sourcefilesTextfields.get(0).setText( this.sourceFile1.getName() );
      }
    }
    else if (evt.getSource() == this.sourcefilesButton.get(1) || evt.getSource()==this.p.opZItem){
      if (this.sourceFile2 != null){
        jFC.setCurrentDirectory( this.sourceFile2 );
        jFC.setSelectedFile( this.sourceFile2 );
      }
      else if (this.sourceFile1 != null){
        jFC.setCurrentDirectory( this.sourceFile1 );
        jFC.setSelectedFile( this.sourceFile1 );
      }
      jFC.setDialogType(JFileChooser.OPEN_DIALOG);
      jFC.setDialogTitle(this.p.lc.getEntry("Opendialog", 0));
      jFC.setApproveButtonText(this.p.lc.getEntry("Opendialog", 1));

      if (jFC.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
        this.sourceFile2 = jFC.getSelectedFile();
        this.sourcefilesTextfields.get(1).setText( this.sourceFile2.getName() );
      }
    }

  }
  
  private void enableApproxValueTextfields(boolean flag){
    if (!flag)
      for (int i=0; i<this.approxValueTextfields.size(); i++)
      this.approxValueTextfields.get(i).setEditable(flag);
    else
      this.setApproxValueVisible();
  }
  
  public void approxValueActionPerformed(ActionEvent evt) {
    if (this.approxValueRadio.get(0).isSelected())
      this.enableApproxValueTextfields(false);
    else
      this.enableApproxValueTextfields(true);
  }
  
  public void setApproxValueVisible() {
    if (this.approxValueRadio.get(0).isSelected())
      return;
    String s = this.p.transSettingP.getTransType();
    for (int i=0; i< this.approxValueTextfields.size(); i++)
      this.approxValueTextfields.get(i).setEditable(false);

    if (s.equals("2P2D1")){
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(4).setEditable(true);
    }
    else if (s.equals("3P2D1")){
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
    }
    else if (s.equals("4P2D1")){
      this.approxValueTextfields.get(0).setEditable(true);
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
    }
    else if (s.equals("4P2D2")){
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(4).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
    }
    else if (s.equals("5P2D1")){
      this.approxValueTextfields.get(0).setEditable(true);
      this.approxValueTextfields.get(3).setEditable(true);
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
    }
    else if (s.equals("5P2D2")){
      this.approxValueTextfields.get(0).setEditable(true);
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(4).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
    }
    else if (s.equals("5P2D3")){
      this.approxValueTextfields.get(0).setEditable(true);
      this.approxValueTextfields.get(3).setEditable(true);
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
    }
    else if (s.equals("6P2D1")){
      this.approxValueTextfields.get(0).setEditable(true);
      this.approxValueTextfields.get(3).setEditable(true);
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(4).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
    }
    else if (s.equals("3P3D1")){
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(4).setEditable(true);
      this.approxValueTextfields.get(7).setEditable(true);
    }
    else if (s.equals("4P3D1")){
      this.approxValueTextfields.get(0).setEditable(true);
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(4).setEditable(true);
      this.approxValueTextfields.get(7).setEditable(true);
    }
    else if (s.equals("6P3D1")){
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(4).setEditable(true);
      this.approxValueTextfields.get(7).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
      this.approxValueTextfields.get(8).setEditable(true);
    }
    else if (s.equals("7P3D1")){
      this.approxValueTextfields.get(0).setEditable(true);
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(4).setEditable(true);
      this.approxValueTextfields.get(7).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
      this.approxValueTextfields.get(8).setEditable(true);
    }
    else if (s.equals("9P3D1")){
      this.approxValueTextfields.get(0).setEditable(true);
      this.approxValueTextfields.get(3).setEditable(true);
      this.approxValueTextfields.get(6).setEditable(true);
      this.approxValueTextfields.get(1).setEditable(true);
      this.approxValueTextfields.get(4).setEditable(true);
      this.approxValueTextfields.get(7).setEditable(true);
      this.approxValueTextfields.get(2).setEditable(true);
      this.approxValueTextfields.get(5).setEditable(true);
      this.approxValueTextfields.get(8).setEditable(true);
    }
  }
  
  public String getModelType(){
//     for (int i=0; i<this.modelTypes.size(); i++)
//      if (this.modelTypes.get(i).isSelected())
//        return this.modelTypes.get(i).getName();
//     return new String("GHM");
     return new String("GMM");
  }

  
}

